- NAME
- SYNOPSIS
- DESCRIPTION
- NOTES
- RETURN VALUES
- HISTORY
- COPYRIGHT

# NAME

OPENSSL_gmtime, OPENSSL_gmtime_adj, OPENSSL_gmtime_diff - platform-agnostic OpenSSL time routines

# SYNOPSIS

     #include <openssl/crypto.h>

     struct tm *OPENSSL_gmtime(const time_t *timer, struct tm *result);
     int OPENSSL_gmtime_adj(struct tm *tm, int offset_day, long offset_sec);
     int OPENSSL_gmtime_diff(int *pday, int *psec,
                            const struct tm *from, const struct tm *to);

# DESCRIPTION

`OPENSSL_gmtime()` returns the UTC time specified by timer into the provided result argument.

`OPENSSL_gmtime_adj()` adds the offsets in offset_day and offset_sec to tm.

`OPENSSL_gmtime_diff()` calculates the difference between from and to.

# NOTES

It is an error to call `OPENSSL_gmtime()` with result equal to NULL. The contents of the time_t given by timer are stored into the result. Calling with timer equal to NULL means use the current time.

`OPENSSL_gmtime_adj()` converts tm into a days and seconds value, adds the offsets, then converts back into a struct tm specified by tm. Leap seconds are not considered.

`OPENSSL_gmtime_diff()` calculates the difference between the two struct tm structures from and to. The difference in days is placed into *pday, the remaining seconds are placed to *psec. The value in *psec will be less than the number of seconds per day (3600). Leap seconds are not considered.

# RETURN VALUES

`OPENSSL_gmtime()` returns NULL on error, or result on success.

`OPENSSL_gmtime_adj()` and `OPENSSL_gmtime_diff()` return 0 on error, and 1 on success.

# HISTORY

`OPENSSL_gmtime()`, `OPENSSL_gmtime_adj()` and `OPENSSL_gmtime_diff()` have been in OpenSSL since 1.0.0.

# COPYRIGHT

Copyright 2022 The OpenSSL Project Authors. All Rights Reserved.

Licensed under the Apache License 2.0 (the "License"). You may not use this file except in compliance with the License. You can obtain a copy in the file LICENSE in the source distribution or at https://www.openssl.org/source/license.html.